USE [COWS]
GO
_CreateObject 'SP','web','updateView'
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
--================================================================================================  
-- Author:  csb9923  
-- Create date: 4/11/2011  
-- Description: inserts the dynamic view  
-- sbg9814	09/09/2011	Changed this to dynamically extract the Views for Orders.
--================================================================================================  
ALTER PROCEDURE [web].[updateView]   
	@VIEWID INT,
	@USERID INT,
	@VIEWNAME VARCHAR(20),
	@SITE_CNTNT_ID INT,
	@DFLTFLAG CHAR(1),
	@PBLCFLAG CHAR(1),
	@FLTRCOLOPR1 VARCHAR(10),
	@FLTRCOLOPR2 VARCHAR(10),
	@FLTRCOL1 INT,
	@FLTRCOL2 INT,
	@FLTRCOLTXT1VAL VARCHAR(50),
	@FLTRCOLTXT2VAL VARCHAR(50),
	@FLTRFLAG CHAR(1),
	@SORTBYCOL1 INT,
	@SORTBYCOL1ORDER CHAR(1),
	@SORTBYCOL2 INT,
	@SORTBYCOL2ORDER CHAR(1),
	@LOGICOPR VARCHAR(10),
	@sCOLIDS VARCHAR(500),
	@sPOS VARCHAR(500)
--	@identity INT OUT
AS
BEGIN  
 
 SET NOCOUNT ON;  
  
 BEGIN TRY  
	
	DECLARE @SITE_CNTNT_COL_VW_CD CHAR(1)
	DECLARE @DSPL_VW_ID INT
	
	SET @DSPL_VW_ID=@VIEWID
	SET @SITE_CNTNT_COL_VW_CD='N'
	DECLARE @ViewDesc VARCHAR(200)
	SET @ViewDesc=''
               
           
   UPDATE [COWS].[dbo].[DSPL_VW] WITH (ROWLOCK)
   SET [USER_ID] = @USERID
      ,[DSPL_VW_NME] = @VIEWNAME
      ,[SITE_CNTNT_ID] = @SITE_CNTNT_ID
      ,[DFLT_VW_CD] = @DFLTFLAG
      ,[PBLC_VW_CD] = @PBLCFLAG
      ,[FILTR_COL_1_OPR_ID] = @FLTRCOLOPR1
      ,[FILTR_COL_2_OPR_ID] = @FLTRCOLOPR2
      ,[FILTR_COL_1_ID] = @FLTRCOL1
      ,[FILTR_COL_2_ID] = @FLTRCOL2
      ,[FILTR_COL_1_VALU_TXT] =@FLTRCOLTXT1VAL
      ,[FILTR_COL_2_VALU_TXT] = @FLTRCOLTXT2VAL
      ,[FILTR_ON_CD] = @FLTRFLAG
      ,[SORT_BY_COL_1_ID] = @SORTBYCOL1
      ,[SORT_BY_COL_2_ID] = @SORTBYCOL2
      ,[MODFD_BY_USER_ID] = @USERID
      ,[MODFD_DT] = GETDATE()
      ,[FILTR_LOGIC_OPR_ID] = @LOGICOPR
      ,[SORT_BY_COL_1_ASC_ORDR_CD] = @SORTBYCOL1ORDER
      ,[SORT_BY_COL_2_ASC_ORDR_CD] = @SORTBYCOL2ORDER
 WHERE DSPL_VW_ID=@DSPL_VW_ID
   	
   	IF @DFLTFLAG='Y'
	  BEGIN
		UPDATE [dbo].[DSPL_VW] WITH (ROWLOCK) SET DFLT_VW_CD='N' WHERE USER_ID=@USERID AND DSPL_VW_ID<>@DSPL_VW_ID
	  END
   	
   	
   	DELETE FROM [DSPL_VW_COL] WITH (ROWLOCK) WHERE DSPL_VW_ID=@DSPL_VW_ID
   		
	DECLARE @DSPL_COL_IDS TABLE (COLID INT, IDENT INT IDENTITY(1,1))
	DECLARE @DSPL_COL_POS TABLE (COLPOS INT, IDENT INT IDENTITY(1,1))	
	
	DECLARE @Ctr INT
	DECLARE @Cnt INT
	DECLARE @DSPL_COL_ID INT
	DECLARE @DSPL_COL_PO INT
	SET @Ctr = 1
	
	INSERT INTO @DSPL_COL_IDS
		SELECT IntegerID FROM web.ParseCommaSeparatedIntegers(@sCOLIDS,',')
	
	INSERT INTO @DSPL_COL_POS
		SELECT IntegerID FROM web.ParseCommaSeparatedIntegers(@sPOS,',')	

	SET @Cnt = (SELECT COUNT(1) FROM @DSPL_COL_IDS)

	WHILE (@Cnt >= @Ctr)
	BEGIN
		SELECT TOP 1 @DSPL_COL_ID = COLID FROM @DSPL_COL_IDS WHERE IDENT = @Ctr
		SELECT TOP 1 @DSPL_COL_PO = COLPOS FROM @DSPL_COL_POS WHERE IDENT = @Ctr

		INSERT INTO [COWS].[dbo].[DSPL_VW_COL]
           ([DSPL_VW_ID]
           ,[DSPL_COL_ID]
           ,[DSPL_POS_FROM_LEFT_NBR]
           ,[CREAT_DT])
		VALUES
           (@DSPL_VW_ID
           ,@DSPL_COL_ID
           ,@DSPL_COL_PO
           ,GETDATE())

		SET @Ctr = @Ctr + 1
	END 

 END TRY  
  
 BEGIN CATCH  
	exec [dbo].[insertErrorInfo]  
 END CATCH  
  
END
GO

